;####################################################
; WoodStock Logo v.1.0 : User Interface Loader
;####################################################
; Informatik 1A: Projekt
;----------------------------------------------------
; BROCCO Amos
; BALABBIO Mara
; STOJANOVIC Tanja
;####################################################

;====================================================
; LIBRERIE SCHEME RICHIESTE
;----------------------------------------------------
(require-library "framework.ss" "framework")
(require-library "macro.ss" "framework")
;____________________________________________________


;====================================================
; APERTURA FILE DEFINIZIONI CLASSI FINESTRE
;----------------------------------------------------
 
 (load "uiclasses.scm")
 (load "delta.scm")
 (load "help.scm")
;____________________________________________________


;====================================================
; VARIABILI GLOBALI
;----------------------------------------------------
(define GfxWindow #f)
(define TranscriptWindow #f)
(define TranscriptEditor #f)
(define lastinput 0)
(define axes? #t)
(define t_action_list '())
(define break? #f)
(define with_debugging? #t)
(define show_log? #f)
;____________________________________________________


;====================================================
; DEFINIZIONE DELLO SPLASH DIALOG
;----------------------------------------------------
(define (show-splash-dialog)
  (update-screen-variables)
    (let ((SplashDialog (make-object dialog% 
                          "Loading Woodstock..." #f 510 384 
          (- (quotient screen-width 2) 255) 
          (- (quotient   screen-height 2) 192) 
                          '(no-caption))))
    (begin
    (make-object ImageCanvas% SplashDialog "splash1.jpg")
    (send SplashDialog show #t))))
;____________________________________________________


;====================================================
; DEFINIZIONE DIALOG ABOUT
;----------------------------------------------------
(define (show-about-dialog)
  (message-box "About Woodstock..." 
"Woodstock 2000/2001
version 1.0 (11.04.2001 22:02)

-I am the Lizard King. I can do anything.-

Amos Brocco, Mara Balabbio & Tanja Stojanovic. 
Informatik 1A: Projekt 2000/2001 iUF UNIFr

To contact the authors
mriya3@yahoo.com

This programs runs on PLT Scheme

LICENSE (PLEASE READ CAREFULLY!)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE.  
See the GNU Library General Public License (GNULGPL.TXT) 
for more details.

You should have received a copy of the 
GNU Library General Public License along with this library;
if not, write to the 
Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"))
;____________________________________________________


;====================================================
; DEFINIZIONE FINESTRA "GRAPHICS"
;----------------------------------------------------
(define (open-GfxWindow)
  (update-screen-variables)
  (let ((x-pos (+ (quotient screen-width 2) 2))
        (y-pos 2)
        (w (- (quotient screen-width 2) 4))
        (h (- screen-height 4)))
    
    (set! GfxWindow (make-object miaframe:standard-menus% 
                      "Graphics - Woodstock LOGO" #f w h x-pos y-pos '(no-resize-border)))
    (send GfxWindow create-status-line)
    (add-menus-gfx GfxWindow)
    (send GfxWindow show #t)
    (set! GfxCanvas (make-object GfxCanvas% 
                      (send GfxWindow get-area-container)))))     
;____________________________________________________


;====================================================
; FUNZIONI PER SCRIVERE NELLA FINESTRA TRANSCRIPT
;----------------------------------------------------
(define (transcript_welcome)
  (delta-print "WoodStock v.1.0 [CODENAME: The Lizard King] / MEV.90 MriyA3" welcome-delta))
 

(define (transcript_prompt)
  (send TranscriptEditor set-position (send TranscriptEditor last-position))
  (set! break? #f)
  (send TranscriptEditor insert #\newline)
  (set-ts-status)
  (color-print "wOoDsToCk> " "blue"))

(define (set-ts-status)
  (send TranscriptWindow set-status-text (converttostring (list 'last lastinput '- '/again '- '/help '- (length t_action_list) '- (length action_list)) 0)))

(define (not-running)
    (send GfxWindow set-status-text "Woodstock 1.0: not running" ))

(define (evaluating)
    (send GfxWindow set-status-text "Evaluating..." ))

(define (print-error-msg theMessage)
  (if (equal? theMessage "User Break!")
  (begin  
    (newline) 
    (play-sound "sounds/break.wav" #t)
    (delta-print theMessage warning-style-delta)
    (send GfxWindow set-status-text "Woodstock 1.0: not running")
    (transcript_prompt))
  (begin
  (newline)
  (play-sound "sounds/error.wav" #t)
  (delta-print (string-append "Error: " theMessage) error-delta)
  (send GfxWindow set-status-text "Woodstock 1.0: not running" )
  (transcript_prompt))))

(define (print-to-transcript TheThing)
  (let ((NewString (ConvertToString TheThing 1)))
    (send TranscriptEditor set-position (send TranscriptEditor last-position))
    (send TranscriptEditor insert NewString)))

(define (push_action action)
   (set! t_action_list (append t_action_list (list action)))
   (set-ts-status))
;____________________________________________________
	

;====================================================
; FUNZIONI DI CONVERSIONE STRINGA<->LISTA
;----------------------------------------------------

;;;****** CONVERSIONE GENERALE A STRINGA*************

(define (ConvertToString TheThing Normal)
  (cond ((string? TheThing) (if (= normal 1) TheThing (string-append "\"" TheThing "\"")))
        ((number? TheThing) (number->string TheThing))
        ((symbol? TheThing) (symbol->string TheThing))
        ((list? TheThing) (list->string TheThing normal ))
        ((pair? TheThing) (string-append "(" (ConvertToString (car TheThing) 1) " . " 
                                                       (ConvertToString (cdr TheThing) 1) 
                                                       " )" )) 

        ((eq? TheThing #f) "#f")
        ((eq? theThing #t) "#t")
        ((primitive-procedure? TheThing) "#<PRIM-PROC>")
        ((compound-procedure? TheThing) "#<COMPOUND-PROC>")
        ((procedure? TheThing) "#<DISPATCH-PROC>")
      (else "")))


(define (cons->list thecons)
  (list (car thecons) (cdr thecons)))


;;;****** CONVERSIONE LISTA->STRINGA*****************

(define (list->string theList normal)
  (string-append "("
                 (ConvertToString (car theList) normal)
                 (apply string-append
                        (map (lambda (item)
                               (string-append " " (ConvertToString item normal)))
                             (cdr theList)))
                 ")"))


;;;****** CONVERSIONE STRINGA->LISTA*****************

(define (extended-read string-from-port)
(define (build-list-of-objects current-port)
  (let ((new-object (read current-port)))
    (if (eof-object? new-object)
       '()
        (cons new-object
              (build-list-of-objects current-port)))))
  (let ((myport (open-input-string string-from-port)))
    (build-list-of-objects myport)))
;____________________________________________________


;====================================================
; READ-EVAL-PRINT DRIVER-LOOP
;----------------------------------------------------
(define (driver-loop)
  (with-handlers ([exn? (lambda (exn) (print-error-msg (exn-message exn)))])
  (let* ((EndPos (send TranscriptEditor get-end-position))
         (StartPos (find-start-position EndPos)))
    (if StartPos
        (if (scheme-paren:balanced? TranscriptEditor StartPos EndPos)
            (let* ((theText (send TranscriptEditor get-text StartPos EndPos #f #f))
                   (TheSequence (extended-read theText))
                   (Status (evaluating))
                   (WhatEvaluate 
                    (cond ((eq? (car TheSequence) '/again) 
                          lastinput)
                          ((eq? (car TheSequence) '/help) lastinput)
                      (else 
                      (car TheSequence))))
                   (TheResult 
                    (cond ((not (eq? (car TheSequence) '/help))
                    (begin
                    (set! break? #f)
                    (myeval WhatEvaluate the-global-environment))))))
              
              (if (not (eq? (car TheSequence) '/help))
                (push_action WhatEvaluate) )
              
              (newline)
              
              (if (or (eq? TheSequence '/help) (eq? (car TheSequence) '/help))
               (begin
                (if (not (eq? (cdr TheSequence) '()))
                (help (cadr TheSequence))
                (help 'Reference)))    
                (delta-print TheResult result-delta))
              
              (set! lastinput WhatEvaluate)
              (set-ts-status)
              (not-running)
              (transcript_prompt)
              )
            )
        (transcript_prompt)))))
;____________________________________________________


;====================================================
; RICERCA INIZIO DELLA STRINGA DA VALUTARE
;----------------------------------------------------
;;;L'INIZIO DELLA STRINGA  DETERMINATO DA UN SEGNO >
;;;PRECEDUTO (10 POSIZIONI PRIMA - CONSIDERIAMO ANCHE
;;;LA SCRITTA WOODSTOCK) DA UN RITORNO A CAPO
;;;WOODSTOCK>

(define (find-start-position EndPos)
  (define (iterSearch pos)
    (cond ((< pos 0) #f)
          ((and (char=? (send TranscriptEditor get-character pos) #\>)
                (char=? (send TranscriptEditor get-character (- pos 10)) #\newline))
           (+ pos 2))
          (else (iterSearch (- pos 1)))))
  (IterSearch (- EndPos 1)))


;____________________________________________________


;====================================================
; DEFINIZIONE DELLA FINESTRA "TRANSCRIPT"
;----------------------------------------------------
(define (setup-transcript)
  (set! TranscriptWindow
        (make-object frame:transcript% "Direct"
          #f (/ screen-width 2) (/ screen-height 2) 0 
          (/ screen-height 2) '(no-resize-border)))
  (set! TranscriptEditor (send TranscriptWindow get-editor))
  (send TranscriptEditor erase)
  (send TranscriptWindow create-status-line)
  (send TranscriptWindow set-status-text "(last 0 - /again - /help - 0 / 0)" )
  (add-ts-menus TranscriptWindow)
  (setup-transcript-panel (send TranscriptWindow get-area-container))
  (transcript_welcome)
  (transcript_prompt)
  (send TranscriptWindow show #t)
  )
;____________________________________________________


;====================================================
; SEQUENZA DI AVVIO DEL PROGRAMMA
;----------------------------------------------------
;;; DEFINIAMO L'AMBIENTE GLOBALE PER IL METAEVALUATOR
(load "metaevaluator.scm")
(load "menus.scm")

;;;INFORMAZIONI SULL'APPLICAZIONE
(application:current-app-name "WoodStock LOGO")

;;;AGGIUNGIAMO I MENU PREDEFINITI
(preferences:add-font-panel)
(preferences:add-general-panel)
(scheme:add-preferences-panel)

;;;VISUALIZZIAMO LO SPLASH DIALOG
;;;(play-sound "sounds/start.wav" #t)
(show-splash-dialog)

;;;VISUALIZIAMO LE FINESTRE
(open-GfxWindow)
(my-new-proc 0 0)
(setup-transcript)


;====================================================
; APERTURA FILE METAEVALUATOR E DEFINIZIONI INIZIALI
;----------------------------------------------------
(load "turtle.scm")

;;;IL PROGRAMMA  IN ESECUZIONE!
(define the-global-environment (setup-environment))

(define (setup-global-environment)
  (set! the-global-environment (setup-environment)))

(not-running)

(draw-the-axes GfxCanvas)


















                       
    




