;####################################################
; WoodStock Logo v.0.81 : Help function
;####################################################
; Informatik 1A: Projekt
;----------------------------------------------------
; BROCCO Amos
; BALABBIO Mara
; STOJANOVIC Tanja
;####################################################

;====================================================
; FUNZIONE PER L'AIUTO
;----------------------------------------------------
;;; Per utilizzare l'aiuto bisogna richiamare
;;; il comando /help <comando>

(define (display stringa)
  (print-to-transcript stringa))

(define (newline) (send TranscriptEditor insert #\newline))

(load "tables.scm")

(define help-table (make-table))

(define get-help (help-table 'lookup-proc))
(define put-help (help-table 'insert-proc!))

(put-help 'reference 1 "[WOODSTOCK LOGO REFERENCE]")
(put-help 'reference 2 "Turtle Functions: /help turtle")
(put-help 'reference 3 "Other graphics functions: /help othergraph")
(put-help 'reference 4 "Other numerical operators:: /help numoperator")
(put-help 'reference 5 "Iterations: /help iterations")
(put-help 'reference 6 "List of all Scheme Primitives recognized: /help primitives")



(put-help 'othergraph 1 "[OTHER GRAPHICS FUNCTIONS] in Woodstock Reference")
(put-help 'othergraph 2 "clearscreen, draw-text")

(put-help 'clearscreen 1 "[CLEARSCREEN] in Other Graphics Functions")
(put-help 'clearscreen 2 "SYNTAX: (clearscreen)")
(put-help 'clearscreen 3 "DESCRIPTION: Clears the graphics screen")

(put-help 'draw-text 1 "[DRAW-TEXT] in Other Graphics Functions")
(put-help 'draw-text 2 "SYNTAX: (draw-text <text> x y)")
(put-help 'draw-text 3 "DESCRIPTION: Writes <text> at position x,y of the graphics window")
(put-help 'maketurtle 4 "RETURN VALUE: none")
(put-help 'maketurtle 5 "EXAMPLE: (draw-text 'Hello World!' 100 10)")



(put-help 'numoperator 1 "[OTHER NUMERICAL OPERATORS] in Woodstock Reference")
(put-help 'numoperator 2 "++ , -- , += , -= , *= , /=")

(put-help '++ 1 "[++] in Other Numerical Operators")
(put-help '++ 2 "SYNTAX: (++ <var>)")
(put-help '++ 3 "DESCRIPTION: Increments <var> by one")
(put-help '++ 4 "RETURN VALUE: <var>")

(put-help '-- 1 "[--] in Other Numerical Operators")
(put-help '-- 2 "SYNTAX: (-- <var>)")
(put-help '-- 3 "DESCRIPTION: Decrements <var> by one")
(put-help '-- 4 "RETURN VALUE: <var>")

(put-help '+= 1 "[+=] in Other Numerical Operators")
(put-help '+= 2 "SYNTAX: (+= <var> <value>)")
(put-help '+= 3 "DESCRIPTION: Increments <var> by <value>")
(put-help '+= 4 "RETURN VALUE: <var>")

(put-help '-= 1 "[-=] in Other Numerical Operators")
(put-help '-= 2 "SYNTAX: (-= <var> <value>)")
(put-help '-= 3 "DESCRIPTION: Decrements <var> by <value>")
(put-help '-= 4 "RETURN VALUE: <var>")

(put-help '*= 1 "[*=] in Other Numerical Operators")
(put-help '*= 2 "SYNTAX: (*= <var> <value>)")
(put-help '*= 3 "DESCRIPTION: Multiply <var> by <value>")
(put-help '*= 4 "RETURN VALUE: <var>")

(put-help '/= 1 "[/=] in Other Numerical Operators")
(put-help '/= 2 "SYNTAX: (/= <var> <value>)")
(put-help '/= 3 "DESCRIPTION: Divides <var> by <value>")
(put-help '/= 4 "RETURN VALUE: <var>")


(put-help 'iterations 1 "[ITERATIONS] in Woodstock Reference")
(put-help 'iterations 2 "repeat, do, while, for")


(put-help 'repeat 1 "[REPEAT] in Iterations")
(put-help 'repeat 2 "SYNTAX: (repeat <n> <expressions>)")
(put-help 'repeat 3 "DESCRIPTION: Repeats <expressions> n times")
(put-help 'repeat 4 "EXAMPLE: (repeat 6 (display 'hi!')(newline)")
(put-help 'repeat 5 "RETURN VALUE: none")

(put-help 'do 1 "[DO] in Iterations")
(put-help 'do 2 "SYNTAX: (do <expressions> until <test>)")
(put-help 'do 3 "DESCRIPTION: Repeats <expressions> until <test> is true")
(put-help 'do 4 "EXAMPLE: (do (display 'hi!')(newline) until (> a 5))")
(put-help 'do 5 "RETURN VALUE: none")

(put-help 'while 1 "[WHILE] in Iterations")
(put-help 'while 2 "SYNTAX: (while <test> <expressions>)")
(put-help 'while 3 "DESCRIPTION: Repeats <expressions> while <test> is true")
(put-help 'while 4 "EXAMPLE: (while (< a 6) (display 'hi!')(newline))")
(put-help 'while 5 "RETURN VALUE: none")

(put-help 'for 1 "[FOR] in Iterations")
(put-help 'for 2 "SYNTAX: (for <var> from <a> to <b> <expressions>)")
(put-help 'for 3 "DESCRIPTION: Declares var equal to a, then repeats <expressions>")
(put-help 'for 4 "incrementing a at each cycle. It stops when a equal to b")
(put-help 'for 5 "EXAMPLE: (for i from 1 to 10 (display 'hi!')(display i)(newline))")
(put-help 'for 6 "RETURN VALUE: none")


(put-help 'primitives 1 "[RECOGNIZED SCHEME PRIMITIVES]")
(put-help 'primitives 2 "Note: no online help available for these topics")
(put-help 'primitives 3 "====================================================")
(put-help 'primitives 4 "car, cdr, cadr, cddr, caddr")
(put-help 'primitives 5 "caar, error, cons, null?, pair?")
(put-help 'primitives 6 "set-car!, set-cdr!, list, length")
(put-help 'primitives 7 "list-tail, list-ref, append, reverse")
(put-help 'primitives 8 "memq, memv, member")
(put-help 'primitives 9 "assq, assv, assoc, not")
(put-help 'primitives 10 "eq?, eqv?, equal?, symbol?")
(put-help 'primitives 11 "max, min, positive?, negative?")
(put-help 'primitives 12 "number?, integer?, rational?, real?")
(put-help 'primitives 13 "complex?, exact?, inexact?, zero?, even?")
(put-help 'primitives 14 "odd?, modulo, remainder, quotient, gcd")
(put-help 'primitives 15 "lcm, numerator, denominator, floor")
(put-help 'primitives 16 "ceiling, truncate, round, exp, log")
(put-help 'primitives 17 "sqrt, expt, apply, abs, +, -, *, /, =")
(put-help 'primitives 18 ">, <, >=, <=, atom?, display, newline,")




(put-help 'turtle 1 "[TURTLE FUNCTIONS] in Woodstock Reference")
(put-help 'turtle 2 "maketurtle, showturtle, hideturtle, penup, pendown")
(put-help 'turtle 3 "setpos, setangle, forward, back , left, right")
(put-help 'turtle 4 "pushturtle, popturtle, gohome, setpenwidth")
(put-help 'turtle 5 "setpenstyle, info, setpencolor")
                                           
(put-help 'maketurtle 1 "[MAKETURTLE] in Turtle Functions")
(put-help 'maketurtle 2 "SYNTAX: (maketurtle <turtle>)")
(put-help 'maketurtle 3 "DESCRIPTION: Creates a new turtle named <turtle>")
(put-help 'maketurtle 4 "RETURN VALUE: see below")
(put-help 'maketurtle 5 "EXAMPLE: (maketurtle new_turtle)")
(put-help 'maketurtle 6 "         (a new turtle named new_turtle is born!)")
(put-help 'maketurtle 7 "SEE ALSO: showturtle")

(put-help 'showturtle 1 "[SHOWTURTLE] in Turtle Functions")
(put-help 'showturtle 2 "SYNTAX: (showturtle <turtle>)")
(put-help 'showturtle 3 "DESCRIPTION: Shows the turtle named <turtle>")
(put-help 'showturtle 4 "RETURN VALUE: On success the turtle is shown, 'ok")
(put-help 'showturtle 5 "EXAMPLE: (showturtle my_turtle)")
(put-help 'showturtle 6 "         'ok")
(put-help 'showturtle 7 "SEE ALSO: hideturtle")

(put-help 'left 1 "[LEFT] in Turtle Functions")
(put-help 'left 2 "SYNTAX: (left <turtle> <n>)")
(put-help 'left 3 "DESCRIPTION: Rotates the <turtle> left by <n> degrees")
(put-help 'left 4 "RETURN VALUE: 'ok")
(put-help 'left 5 "EXAMPLE: (left my_turtle 45)")
(put-help 'left 6 "         'ok")
(put-help 'left 7 "SEE ALSO: right")

(put-help 'right 1 "[RIGHT] in Turtle Functions")
(put-help 'right 2 "SYNTAX: (right <turtle> <n>)")
(put-help 'right 3 "DESCRIPTION: Rotates the <turtle> right by <n> degrees")
(put-help 'right 4 "RETURN VALUE: 'ok")
(put-help 'right 5 "EXAMPLE: (right my_turtle 45)")
(put-help 'right 6 "         'ok")
(put-help 'right 7 "SEE ALSO: left")

(put-help 'pendown 1 "[PENDOWN] in Turtle Functions")
(put-help 'pendown 2 "SYNTAX: (pendown <turtle>)")
(put-help 'pendown 3 "DESCRIPTION: Enables the turtle's pen")
(put-help 'pendown 4 "RETURN VALUE: 'ok")
(put-help 'pendown 5 "EXAMPLE: (pendown my_turtle)")
(put-help 'pendown 6 "         'ok")
(put-help 'pendown 7 "SEE ALSO: penup")

(put-help 'penup 1 "[PENUP] in Turtle Functions")
(put-help 'penup 2 "SYNTAX: (penup <turtle>)")
(put-help 'penup 3 "DESCRIPTION: Disables the turtle's pen")
(put-help 'penup 4 "RETURN VALUE: 'ok")
(put-help 'penup 5 "EXAMPLE: (penup my_turtle)")
(put-help 'penup 6 "         'ok")
(put-help 'penup 7 "SEE ALSO: pendown")

(put-help 'popturtle 1 "[POPTURTLE] in Turtle Functions")
(put-help 'popturtle 2 "SYNTAX: (popturtle <turtle>)")
(put-help 'popturtle 3 "DESCRIPTION: Retrieves the turtle's position and angle from the stack")
(put-help 'popturtle 4 "RETURN VALUE: 'ok")
(put-help 'popturtle 5 "EXAMPLE: (popturtle my_turtle)")
(put-help 'popturtle 6 "         'ok")
(put-help 'popturtle 7 "SEE ALSO: pushturtle")

(put-help 'pushturtle 1 "[PUSHTURTLE] in Turtle Functions")
(put-help 'pushturtle 2 "SYNTAX: (pushturtle <turtle>)")
(put-help 'pushturtle 3 "DESCRIPTION: Stores the turtle's current position and angle in the stack")
(put-help 'pushturtle 4 "RETURN VALUE: 'ok")
(put-help 'pushturtle 5 "EXAMPLE: (pushturtle my_turtle)")
(put-help 'pushturtle 6 "         'ok")
(put-help 'pushturtle 7 "SEE ALSO: popturtle")

(put-help 'forward 1 "[FORWARD] in Turtle Functions")
(put-help 'forward 2 "SYNTAX: (forward <turtle> <distance>)")
(put-help 'forward 3 "DESCRIPTION: Moves the turtle forward by <distance> pixels")
(put-help 'forward 4 "RETURN VALUE: 'ok")
(put-help 'forward 5 "EXAMPLE: (forward my_turtle 100)")
(put-help 'forward 6 "         'ok")
(put-help 'forward 7 "SEE ALSO: back")

(put-help 'back 1 "[BACK] in Turtle Functions")
(put-help 'back 2 "SYNTAX: (back <turtle> <distance>)")
(put-help 'back 3 "DESCRIPTION: Moves the turtle backward by <distance> pixels")
(put-help 'back 4 "RETURN VALUE: 'ok")
(put-help 'back 5 "EXAMPLE: (back my_turtle 100)")
(put-help 'back 6 "         'ok")
(put-help 'back 7 "SEE ALSO: forward")

(put-help 'setpos 1 "[SETPOS] in Turtle Functions")
(put-help 'setpos 2 "SYNTAX: (setpos <turtle> <x> <y>)")
(put-help 'setpos 3 "DESCRIPTION: Sets the turtle position to x y")
(put-help 'setpos 4 "RETURN VALUE: 'ok")
(put-help 'setpos 5 "EXAMPLE: (setpos my_turtle 100 34)")
(put-help 'setpos 6 "         'ok")
(put-help 'setpos 7 "SEE ALSO: setangle")

(put-help 'setangle 1 "[SETANGLE] in Turtle Functions")
(put-help 'setangle 2 "SYNTAX: (setangle <turtle> <angle>)")
(put-help 'setangle 3 "DESCRIPTION: Sets the turtle angle to <angle>")
(put-help 'setangle 4 "RETURN VALUE: 'ok")
(put-help 'setangle 5 "EXAMPLE: (setangle my_turtle 100 34)")
(put-help 'setangle 6 "         'ok")
(put-help 'setangle 7 "SEE ALSO: setpos")

(put-help 'gohome 1 "[GOHOME] in Turtle Functions")
(put-help 'gohome 2 "SYNTAX: (gohome <turtle>)")
(put-help 'gohome 3 "DESCRIPTION: Sets the turtle angle to 0 and position to 0,0")
(put-help 'gohome 4 "RETURN VALUE: 'ok")
(put-help 'gohome 5 "EXAMPLE: (gohome my_turtle)")
(put-help 'gohome 6 "         'ok")

(put-help 'setpenwidth 1 "[SETPENWIDTH] in Turtle Functions")
(put-help 'setpenwidth 2 "SYNTAX: (setpenwidth <turtle> <n>)")
(put-help 'setpenwidth 3 "DESCRIPTION: Sets the turtle's pen width to <n>")
(put-help 'setpenwidth 4 "RETURN VALUE: 'ok")
(put-help 'setpenwidth 5 "EXAMPLE: (setpenwidth my_turtle 4)")
(put-help 'setpenwidth 6 "         'ok")
(put-help 'setpenwidth 7 "SEE ALSO: setpencolor")

(put-help 'setpencolor 1 "[SETPENCOLOR] in Turtle Functions")
(put-help 'setpencolor 2 "SYNTAX: (setpencolor <turtle> <color>)")
(put-help 'setpencolor 3 "DESCRIPTION: Sets the turtle's pen color to <color>")
(put-help 'setpencolor 4 "RETURN VALUE: 'ok")
(put-help 'setpencolor 5 "EXAMPLE: (setpencolor my_turtle 'red')")
(put-help 'setpencolor 6 "         'ok")
(put-help 'setpencolor 7 "SEE ALSO: setpenstyle")

(put-help 'setpenstyle 1 "[SETPENSTYLE] in Turtle Functions")
(put-help 'setpenstyle 2 "SYNTAX: (setpenstyle <turtle> <style>)")
(put-help 'setpenstyle 3 "DESCRIPTION: Sets the turtle's pen style to <style>")
(put-help 'setpenstyle 4 "RETURN VALUE: 'ok")
(put-help 'setpenstyle 5 "EXAMPLE: (setpenstyle my_turtle 'dot)")
(put-help 'setpenstyle 6 "         'ok")
(put-help 'setpenstyle 7 "SEE ALSO: setpenwidth")

(put-help 'info 1 "[INFO] in Turtle Functions")
(put-help 'info 2 "SYNTAX: (info <turtle>)")
(put-help 'info 3 "DESCRIPTION: Returns informations about the turtle")
(put-help 'info 4 "RETURN VALUE: see below")
(put-help 'info 5 "EXAMPLE: (info my_turtle)")
(put-help 'info 6 "(x: 0 y: 0 angle: 0 color: black width: 1 style: solid showturtle? #f pendown? #f)")











(define (write-help-contents topic count)
  (if (not (eq? (get-help topic count) #f))
  (begin
   (newline)
   (color-print (get-help topic count) "dark green")
   (write-help-contents topic (+ count 1)))))

(define (help topic) 
 
  (if (eq? (get-help topic 1) #f) 
      (begin
      (display topic)
      (newline)
      (delta-print "Topic not found!" error-delta))
  (
  begin 
  (delta-print "====================================================" result-delta)
  (newline)
  (delta-print (get-help topic 1) output-delta)
  (newline)
  (delta-print "----------------------------------------------------" result-delta)
  (write-help-contents topic 2) 
  (newline)
  (delta-print "____________________________________________________" result-delta))))

