;####################################################
; WoodStock Logo v.1.0 : User Interface Classes
;####################################################
; Informatik 1A: Projekt
;----------------------------------------------------
; BROCCO Amos
; BALABBIO Mara
; STOJANOVIC Tanja
;####################################################

(require-library "macro.ss" "framework")
(require-library "framework.ss" "framework")
(define exiting? #f)


(define (axes-X canvas) (quotient (send canvas get-width) 2))
(define (axes-Y canvas) (quotient (send canvas get-height) 2))

(define (draw-the-axes canvas)
 (if axes?
  (let ((mypen (make-object pen% "black" 1 'dot)))
  (send (send canvas get-dc) set-pen mypen)
  (send (send canvas get-dc) draw-line 0 (axes-y canvas) (* 2 (axes-x canvas)) (axes-y canvas))
  (send (send canvas get-dc) draw-line (axes-x canvas) 0 (axes-x canvas) (* (axes-y canvas) 2)))))
   

;1. Funzioni per sapere le dimensioni dello schermo...
;*****************************************************

; Definiamo innanzitutto le variabili di larghezza e
; di altezza dello schermo e poniamole a 0
(define screen-width 0)
(define screen-height 0)

; Funzione per aggiornare le dimensioni
(define (update-screen-variables)
  (let-values (((width height) (get-display-size)))
    (set! screen-width width)
    (set! screen-height height)))

; Ricaviamo la dimensione interna della finestra (larghezza)
(define (window-inner-width theWindow)
  (let-values (((width height) (send theWindow get-client-size)))
    width))

; Ricaviamo la dimensione interna della finestra (altezza)
(define (window-inner-height theWindow)
  (let-values (((width height) (send theWindow get-client-size)))
    height))

; Variabili globali per la finestra e il canvas
(define GfxWindow #f)
(define GfxCanvas #f)


; Definizione della sottoclasse ImageCanvas% derivata da canvas%
(define ImageCanvas%
  (class canvas% (theDialog theImageFile)
    (private
      (image-bmp (make-object bitmap% theImageFile 'jpeg)))
    (override
      [on-paint (lambda ()(begin (send (send this get-dc) draw-bitmap image-bmp 0 0)(sleep 4)(send theDialog on-exit)))]
      )
    (sequence
      (super-init theDialog)
      
        (if (send image-bmp ok?)
          (let-values (((dialogW dialogH) (send theDialog get-size))
            ((canvasW canvasH) (send theDialog get-client-size))
            ((bmpW) (send image-bmp get-width))
            ((bmpH) (send image-bmp get-height)))
          (send theDialog resize (+ bmpW (- dialogW canvasW))
                (+ bmpH (- dialogH canvasH) 0))
          (send theDialog show #f))))))
        

; definizione della classe frame:standard-menus%
(define miaframe:standard-menus%
  (class frame:standard-menus% (label parent w h x y (style '()))
    (rename
    (old-can-close? can-close?))
    (public
    [extern-can-close? (lambda() (old-can-close?))])
    (override
      [help-menu:about-string (lambda () "Woodstock")]
      [help-menu:about (lambda (item ev) (show-about-dialog))]
      [can-close? (lambda () (close-if-exiting this))] 
      [file-menu:quit close-all]) 
     (sequence
      (super-init label parent w h x y style))))


; definizione della classe GfxCanvas%
(define GfxCanvas%
  (class canvas% (frame)
    (private
      [back-bmp (make-object bitmap% (window-inner-width frame) (window-inner-height frame))])
    (public
      [back-dc #f]
      [clear-screen (lambda () (send frame clear)  )])
    (override
      ; funzione aggiunta v.81
      [on-paint 
       (lambda () 
         (begin
         (send (send this get-dc) draw-bitmap back-bmp 0 0))
         (draw-the-axes this))  ]
    )
    (sequence
      (super-init frame)
      (if (send back-bmp ok?)
          (begin
            (set! back-dc (make-object bitmap-dc% back-bmp))
            (send back-dc clear))
          (message-box "Error" "Not enough memory to save this frame!")))))


; DESCRIPTION: The editor class for the transcript...
(define transcript:return%
  (class text:return% ((return driver-loop))
    (sequence (super-init return))))


(define transcript:editor% (scheme:text-mixin transcript:return%))

;;; Definizione della classe frame per la finestra Transcript e editor
(define my-frame%
  (class frame:searchable% (name parent width height x y style editor-class)
    (override
      [file-menu:new my-new-proc]
      [file-menu:open my-open-proc]
      [file-menu:save-as my-save-proc]
      [help-menu:about-string (lambda () "WoodStock LOGO")]
      [help-menu:about (lambda (x y) (show-about-dialog))]
      [get-editor<%> (lambda () scheme:text<%>)]
      [get-editor% (lambda () editor-class)])
    (sequence (super-init name parent width height x y style))))

(define frame:transcript%
  (class my-frame% (name parent width height x y style)
    ;;; Aggiunte per impedire la chiusura di tutte le finestre.
    ;;; Se viene chiusa la finestra Transcript viene terminato il programma
    (rename
      (old-can-close? can-close?))
    (public
       [extern-can-close? (lambda() (old-can-close?))])
    (override
      [can-close? (lambda () (close-if-exiting this))] 
      [file-menu:quit close-all] )
    ;;; Fine aggiunte 
    (sequence (super-init name parent width height x y style transcript:editor%))))

(define frame:scheme-editor%
  (class my-frame% (name parent width height x y style)
       (sequence (super-init name parent width height x y style scheme:text%))))

;;; Nuova funzione di apertura dei files
(define (my-open-proc item control)
  (let ((theFile (finder:get-file)))
    (if theFile
        (let ((theWindow (make-object frame:scheme-editor%
                           (file-name-from-path theFile) #f (/ screen-width 2) (/ screen-height 2) 0 0 '())))
          (send (send theWindow get-editor) load-file theFile 'text #f)
          (add-menus theWindow) 
          (setup-cmd-panel (send theWindow get-area-container))
          (send theWindow show #t)
          ))))

;;; Nuova funzione per la creazione di un nuovo file
;;; Il programma crea una nuova finestra di editor col nome Untitled <n>.
;;; Per ricavare <n> utilizza la funzione next-untitled-name
(define (my-new-proc item control)
  (let ((theWindow (make-object frame:scheme-editor%
                     (gui-utils:next-untitled-name) #f (/ screen-width 2) (/ screen-height 2) 0 0 '())))
    (add-menus theWindow)
    (setup-cmd-panel (send theWindow get-area-container))
    (send theWindow show #t)))

(define (my-save-proc item control)
  (let ((theWindow (send (send (send item get-parent) get-parent) get-frame))
        (theFile (finder:put-file)))
    (when theFile
      (send (send theWindow get-editor) save-file theFile 'text #f)
      (send theWindow set-label (file-name-from-path theFile)))))

;;; Funzione che permette la chiusura della finestra in caso di EXIT
(define close-if-exiting
   (lambda (this) (if exiting?
                (send this extern-can-close?)
                #f)))

;;; Funzione per la chiusura della finestra
(define normal-close
   (lambda (this)(send this extern-can-close?)
   ))

;;; Funzione per chiudere tutte le finestre tramite un EXIT
(define close-all
   (lambda(item control)
     (set! exiting?  #t)
     (exit:exit)
     (set! exiting?  #f)
     ))
